#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
//#include <unistd.h>
//#include <fcntl.h>
//#include <sys/types.h>
//#include <sys/socket.h>
#define COMMAND_LENGTH 80

int main(int argc, char *argv[]){
  int port, sockStream, num;
  struct hostent *host;
  struct sockaddr_in servaddr;  

  /** Controllo degli argomenti **/
  if(argc!=3){
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }
  num=0;
  while(argv[2][num]!='\0'){
    if(argv[2][num]<'0' || argv[2][num] >'9'){
      printf("port must be a number!\n");
      exit(2);
    }
    num++;
  }
  port = atoi(argv[2]);
  /****/

  /** Creazione e connessione socket **/
  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  host = gethostbyname(argv[1]);
  if (host == NULL){
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(3);
  }
  servaddr.sin_addr.s_addr=((struct in_addr*) (host->h_addr))->s_addr;
  servaddr.sin_port = htons(port);
  printf("Client ON\n");
  /****/

  /** CORPO DEL CLIENT **/
	
  char stringa[COMMAND_LENGTH];
  printf("Digita comando e argomenti da inviare, invio per terminare\n");
	while( strlen(gets(stringa)) > 0 ){
	  
	  //connessione socket
	  sockStream=socket(AF_INET, SOCK_STREAM, 0);
    if (sockStream <0){
      perror("apertura socket ");
      exit(4);
    } else if (connect(sockStream,(struct sockaddr *) &servaddr, sizeof(struct sockaddr))<0){
      perror("Errore in connect");
      exit(5);
    }
    
    // invio del comando su socket
    write(sockStream,&stringa,strlen(stringa)+1);    
    char c;
    int nLetti;
    while(  (nLetti=read(sockStream,&c,sizeof(char))) == 1  ){
      printf("%c",c);
      fflush(stdout);
    }
    if(nLetti<0) perror("Lettura da socket");
    close(sockStream);
    printf("Digita comando e argomenti da inviare, invio per terminare\n");
  }
  /** FINE DEL CORPO DEL CLIENT **/
  
  /** Chiusura socket **/
  printf("Client OFF\n");
  close(sockStream);
  /****/
  exit(0);  
}

