#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <errno.h>
//#include <unistd.h>
//#include <sys/types.h>
//#include <netinet/in.h>
//#include <dirent.h>
//#include <fcntl.h>
#define COMMAND_LENGTH 80

int main(int argc, char* argv[])
{
  struct hostent *host;
  struct sockaddr_in clientaddr, servaddr;
  int  socketDgram,len,port,num;

  /** Controllo degli argomenti **/
  if(argc!=3){
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }
  num=0;
  while(argv[2][num]!='\0'){
    if(argv[2][num]<'0' || argv[2][num] >'9'){
      printf("port must be a number!\n");
      exit(2);
    }
    num++;
  }
  port = atoi(argv[2]);
  /****/

  /** Apertura socket **/
  memset((char *)&clientaddr, 0, sizeof(struct sockaddr_in));
  clientaddr.sin_family = AF_INET;
  clientaddr.sin_addr.s_addr = INADDR_ANY;  
  clientaddr.sin_port = 0;
  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  host = gethostbyname (argv[1]);
  if (host == NULL){
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(3);
  } else{
    servaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
    servaddr.sin_port = htons(port);
  }
  socketDgram=socket(AF_INET, SOCK_DGRAM, 0);
  if(socketDgram<0){
    perror("apertura socket");
    exit(4);
  } else if(bind(socketDgram,(struct sockaddr *) &clientaddr, sizeof(clientaddr))<0){
    perror("bind socket ");
    exit(5);
  }
  len=sizeof(servaddr);
  printf("Client ON\n");
  
  /** CORPO DEL CLIENT **/
  
  char stringa[COMMAND_LENGTH];
  printf("Digita comando e argomenti da inviare, invio per terminare\n");
	while( strlen(gets(stringa)) > 0 ){
    
    // invio del comando al server
    len=sizeof(servaddr);
    if (sendto(socketDgram, stringa, strlen(stringa)+1, 0, (struct sockaddr *)&servaddr, len)<0){
      perror("scrittura socket");
      exit(6);
    }
    // ricezione del valore di ritorno
    int returnValue; 
    if (recvfrom(socketDgram, &returnValue, sizeof(int), 0, (struct sockaddr *)&servaddr, &len)<0){
      perror("recvfrom");
      exit(7);
    }
    returnValue = ntohl(returnValue);
    printf("Valore di ritorno: %d\n",returnValue);
    printf("Digita comando e argomenti da inviare, invio per terminare\n");
  }
  /**  FINE CORPO CLIENT **/
  
  printf("Client: OFF\n");
  close(socketDgram);
  exit(0);
}

